#include <ctype.h>
#include <cstring.h>
#include <StrUtl.h>
#include <StrUtils.h>

static void strip1( string& a )
{
    while( a.length() > 0 && isspace( a[0] ) )
		a.remove( 0, 1 );
    while( a.length() > 0 && isspace( a[a.length()-1] ) )
        a.remove( a.length()-1, 1 );
    for( int i = 0; i < a.length(); i++ )
        a(i) = toupper(a[i]);
}

static void strip2( string& a )
{
	for(;;)
	{
		int i = pos("\xff",a);  // fake space
		if( i < 0 ) break;

        a(i) = ' ';         // normal space
	}

	for(;;)
	{
		int i = pos("  ",a);
		if( i < 0 ) break;

		a.remove( i, 1 );
	}
}

static void strip3( string& a )
{
	string b = "";
    for( int i = 0; i < a.length(); i++ )
    {
        if( isalnum(a[i]) && (unsigned char)a[i] < 168 )
            b += a[i];
    }
    a = b;
}

void stripstring( string& a, int level )
{
    if( level < 1 ) return;
    strip1(a);
    if( level < 2 ) return;
    strip2(a);
    if( level < 3 ) return;
    strip3(a);
}

// Returns 0 if the strings are different
// Returns 1 if the strings are somewhat similar
// Returns 2 if the strings are pretty close
// Returns 3 if the strings are virtually identical
int similarstrings( string a, string b )
{
    strip1(a);
    strip1(b);
    if( eq(a,b) ) return 3;

    strip2(a);
    strip2(b);
    if( eq(a,b) ) return 2;

    strip3(a);
	strip3(b);
	int diff = 0;
    if( a.length() - b.length() > 2 || b.length() - a.length() > 2 )
		return 0;
    for( int i = 0; i < a.length() && i < b.length(); i++ )
		if( toupper(a[i]) != toupper(b[i]) )
			diff++;
    if( diff * 10 < a.length() + b.length() )
		return 3;
	return 0;
}

